from ..context import SfgContext
from .prepare import prepare_context
from .printers import SfgHeaderPrinter, SfgImplPrinter
from .clang_format import invoke_clang_format


class StringEmitter:
    def __init__(self, ctx: SfgContext):
        self._ctx = prepare_context(ctx)

    def get_header_code(self):
        printer = SfgHeaderPrinter(self._ctx)
        code = printer.get_code()
        code = invoke_clang_format(code, self._ctx.codestyle)

        return code

    def get_impl_code(self, assoc_header: str):
        printer = SfgImplPrinter(self._ctx, assoc_header)
        code = printer.get_code()
        code = invoke_clang_format(code, self._ctx.codestyle)

        return code
